Node.js学习总结-----package.json

什么是package.json?
package.json文件是一个项目一种展示方式。
它是工具配置的中央存储库。 这也是 npm 和 yarn 存储所有已安装包的名称和版本的地方。

1.文件结构

下面是package.json文件的一个例子:

{}

这是一个空对象。对于一个应用中的package.json文件来说,除了需要遵守JSON格式,没有任何固定的要求。
但是如果你正在构建一个想要通过 npm 分发的 Node.js 包,事情的性质不太一样了,必须有一组属性来帮助其他人使用它。

这是另外一个package.json文件:

{
  "name": "test-project"
}

这个文件中,定义了name属性,这个属性可以定义app或者包的名称。

下面这个文件有更多的属性:

{
  "name": "test-project",
  "version": "1.0.0",
  "description": "A Vue.js project",
  "main": "src/main.js",
  "private": "true",
  "scripts": {
    "dev": "webpack-dev-server --inline --progress --config build/webpack.dev.conf.js",
    "start": "npm run dev",
    "unit": "jest --config test/unit/jest.conf.js --coverage",
    "test": "npm run unit",
    "lint": "eslint --ext .js,.vue src test/unit",
    "build": "node build/build.js"
  },
  "depedencies": {
    "vue": "^2.5.2"
  },
  "devDependencies": {
    "autoprefixer": "^7.1.2",
    "babel-core": "^6.22.1",
    "babel-eslint": "^8.2.1",
    "babel-helper-vue-jsx-merge-props": "^2.0.3",
    "babel-jest": "^21.0.2",
    "babel-loader": "^7.1.1",
    "babel-plugin-dynamic-import-node": "^1.2.0",
    "babel-plugin-syntax-jsx": "^6.18.0",
    "babel-plugin-transform-es2015-modules-commonjs": "^6.26.0",
    "babel-plugin-transform-runtime": "^6.22.0",
    "babel-plugin-transform-vue-jsx": "^3.5.0",
    "babel-preset-env": "^1.3.2",
    "babel-preset-stage-2": "^6.22.0",
    "chalk": "^2.0.1",
    "copy-webpack-plugin": "^4.0.1",
    "css-loader": "^0.28.0",
    "eslint": "^4.15.0",
    "eslint-config-airbnb-base": "^11.3.0",
    "eslint-friendly-formatter": "^3.0.0",
    "eslint-import-resolver-webpack": "^0.8.3",
    "eslint-loader": "^1.7.1",
    "eslint-plugin-import": "^2.7.0",
    "eslint-plugin-vue": "^4.0.0",
    "extract-text-webpack-plugin": "^3.0.0",
    "file-loader": "^1.1.4",
    "friendly-errors-webpack-plugin": "^1.6.1",
    "html-webpack-plugin": "^2.30.1",
    "jest": "^22.0.4",
    "jest-serializer-vue": "^0.3.0",
    "node-notifier": "^5.1.2",
    "optimize-css-assets-webpack-plugin": "^3.2.0",
    "ora": "^1.2.0",
    "portfinder": "^1.0.13",
    "postcss-import": "^11.0.0",
    "postcss-loader": "^2.0.8",
    "postcss-url": "^7.2.1",
    "rimraf": "^2.6.0",
    "semver": "^5.3.0",
    "shelljs": "^0.7.6",
    "uglifyjs-webpack-plugin": "^1.1.1",
    "url-loader": "^0.5.8",
    "vue-jest": "^1.0.2",
    "vue-loader": "^13.3.0",
    "vue-style-loader": "^3.0.1",
    "vue-template-compiler": "^2.5.2",
    "webpack": "^3.6.0",
    "webpack-bundle-analyzer": "^2.9.0",
    "webpack-dev-server": "^2.9.1",
    "webpack-merge": "^4.1.0"
  },
  "engines": {
    "node": ">= 6.0.0",
    "npm": ">=3.0.0"
  },
  "browserslist": ["> 1%", "last 2 versions","not ie<=8"]
}

version表明了当前的版本
description是app/包 的简要描述
main设置应用的入口处
private如果被设置为true,将会阻止app/包 在npm上意外发布
scripts定义了一系列开发人员可以运行的node脚本
dependencies设置了一系列的需要被安装的包
devDependencies设置了一系列的开发时需要被安装的包
engines设置了当前包/app 应该运行的node.js的版本
browserslist被用来告诉这个项目你希望支持的浏览器版本

2.属性拆分

这一部分详细介绍可以使用的属性。指的是“包”的属性,但同样也适用于不用作包的本地应用程序。

大多数这些属性仅在 https://www.npmjs.com/ 上使用,其他属性则由与您的代码交互的脚本使用,例如 npm 或其他。

2.1 name

设置包的名称。
例子:
"name": "test-project"
这个名称必须要小于214个字符,只能包含小写字母,连字符和下划线。

2.2 author

罗列包的作者名称

{
  "author": "Joe(http://whatever.com)"
}

2.3 contributors

和author一样,一个项目有一个或者多个贡献者。这个属性是一个数组。

{
  "contributors": ["Joe  (https://whatever.com)"]
}

2.4 bugs

包的问题跟踪器的链接,就像是 GitHub 问题页面。

{
  "bugs": "https://github.com/whatever/package/issues"
}

2.5 homepage

设置包的主页

{
  "homepage": "https://whatever.com/package"
}

2.6 version

显示包的当前版本。

{
  "version": "1.0.0"
}

2.7 license

显示包的许可证。

{
  "license": "MIT"
}

2.8 keywords

此属性包含一组与包的功能相关联的关键字。

{
  "keywords": [
    "email",
    "machine learning",
    "ai"
  ]
}

2.9 description

此属性包含了包的简要描述。

{
  "description": "A package to work woth strings"
}

2.10 repository

此属性具体描述了这个包的库位于什么位置。

{
  "repository": "github:whatever/testing"
}

2.11 main

设置包的入口处。

{
  "main": "scr/main.js"
}

2.12 private

如果被设置为true,将会阻止app/包 在npm上意外发布。

{
  "private": true
}

2.13 scripts

定义了一系列开发人员可以运行的node脚本。

{
  "scripts": {
    "dev": "webpack-dev-server --inline --progress --config build/webpack.dev.conf.js",
    "start": "npm run dev",
    "unit": "jest --config test/unit/jest.conf.js --coverage",
    "test": "npm run unit",
    "lint": "eslint --ext .js,.vue src test/unit",
    "build": "node build/build.js"
  }
}

2.14 dependencies

设置了一系列的需要被安装的包。

{
  "dependencies": {
    "vue": "^2.5.2"
  }
}

2.15 devDependencies

设置了一系列的开发时需要被安装的包。

{
  "devDependencies": {
    "autoprefixer": "^7.1.2",
    "babel-core": "^6.22.1"
  }
}

2.16 engines

设置了当前包/app 应该运行的node.js的版本。

{
  "engines": {
    "node": ">= 6.0.0",
    "npm": ">= 3.0.0",
    "yarn": "^0.13.0"
  }
}

2.17 browserslist

被用来告诉这个项目你希望支持的浏览器版本。

{
  "browserslist": [
    "> 1%",
    "last 2 versions",
    "not ie <= 8"
 ]
}

你可能感兴趣的